export interface SuccessfulValidation<T = any> {
    success: true;
    value: T;
}
declare type TypeOfFailure = 'WRONG_TYPE' | 'MISSING_KEYS' | 'EXCESS_KEYS' | 'INTERNAL_ERROR' | 'CALLBACK_FAILED';
export interface FailedValidation {
    success: false;
    type: TypeOfFailure;
    message: string;
}
export declare const VALID_INPUT: <T>(value: T) => SuccessfulValidation<T>;
export declare const INVALID_INPUT: (type: TypeOfFailure, message: string) => FailedValidation;
export declare const WRONG_TYPE_INPUT: (message: string) => FailedValidation;
export declare const MISSING_KEYS_INPUT: (message: string) => FailedValidation;
export declare const EXCESS_KEYS_INPUT: (message: string) => FailedValidation;
export declare const INTERNAL_ERROR: (message: string) => FailedValidation;
export declare const CALLBACK_FAILED: (message: string) => FailedValidation;
export {};
